﻿Imports System.Text
Imports System.Data.Objects

Imports DomainModel
Imports IdeaBlade.Core
Imports IdeaBlade.EntityModel

Namespace Console01
  Friend Class Program
	Shared Sub Main(ByVal args() As String)
	  CType(New Program(), Program).DoIt()
	End Sub

	Private Sub DoIt()
	  _context = New DomainModelEntityManager()
	  Dim aCustomer As Customer = _context.Customers.Where(Function(c) c.Orders.Any()).FirstOrNullEntity()

	  If aCustomer.Orders.Count > 0 Then
		Console.WriteLine("Got customer " & aCustomer.CompanyName)
		Console.WriteLine("Customer has " & aCustomer.Orders.Count & " orders.")
		Dim sumOfOrderDetails As Integer = 0
		Dim internationalOrders As Integer = 0
		For Each anOrder As Order In aCustomer.Orders
		  sumOfOrderDetails += anOrder.OrderDetails.Count()
		  internationalOrders += (If(anOrder.InternationalOrder.EntityAspect.IsNullEntity, 0, 1))
		Next anOrder
		Console.WriteLine("Customer has " & sumOfOrderDetails & " total line items (OrderDetails).")
		Console.WriteLine("Customer has " & internationalOrders & " total internatinal orders.")

		' Delete only the customer.
		aCustomer.EntityAspect.Delete()

		' Cascade rules will cascade the delete to objects in entity cache.
		' Use FindEntities to find all deleted objects.
		Dim deletedObjects As IEnumerable(Of Object) = _context.FindEntities(IdeaBlade.EntityModel.EntityState.Deleted).Cast(Of Object)()
		Dim numberOfObjectsDeleted As Integer = deletedObjects.Count()

		Console.WriteLine(numberOfObjectsDeleted & " entities were marked for deletion.")

		' We won't delete the graph here, but if you want to remove these entities from the database uncomment the code below.
		'SaveResult sr = _context.SaveChanges();

	  End If
	  PromptToContinue()
	End Sub

	Private Sub PromptToContinue()
	  Console.WriteLine()
	  Console.WriteLine("Press ENTER to continue...")
	  Console.ReadLine()
	End Sub

	#Region "Private Fields"
	Private _context As DomainModelEntityManager
	#End Region ' Private Fields
  End Class
End Namespace
